const
	width=320;//constant containing the width of the screen.
global
	terra[320];//this integer array will hold the interpolated values
	points[20];//this integer array will hold the randomly generated points.
//GENERATING
/*
method putting the actual interpolated values in the int array.
and also draws the land (or removes the not land from a green screen ^^)
*/
function makeland(nbpoints, segmentation,colorbacka,colorbackb,colorfronta,colorfrontb,int min,int max)
private
	i;
	segment;
	pointspersegment;
begin
	segment = width/segmentation;//the widht of a segment (rounded down!!!!)
	pointspersegment = (nbpoints +segmentation-1)/segmentation;//this tho has to be a whole number, be cautious for that!!!
	generatepoints(nbpoints, segmentation,min,max);//and now we can generate the points :)	
	map_clear(0,0,colorfronta);//simply clear the background with the terrain color :)
	for(i=0;i<segmentation-1; i++)//-1, the last segment will be done manually, to make sure we go over the full length
		createland(pointspersegment, i*(pointspersegment-1),segment*i,segment*(i+1),colorbacka,colorbackb,colorfronta,colorfrontb);//and for each segment we generate the land :)
	end;
	createland(pointspersegment, (segmentation-1)*(pointspersegment-1),segment*(segmentation-1),width,colorbacka,colorbackb,colorfronta,colorfrontb);//the last segment :)                            
end;
/*
method generating the points over which we interpolate.
it makes sure the points at the border of 2 segments will cause a smooth landscape
*/
function generatepoints(nbpoints, segmentation,min,max)
private
	i;
	ppsegment;//points per segment
	currentpoint;
	okay=-1;//will be used to make sure we got a correct set of points :)
begin
	while((nbpoints+segmentation-1)mod(segmentation)!=0)//just making sure we got a whole number of points per segment...
	  nbpoints--;
	end;
	ppsegment = (nbpoints+segmentation-1)/segmentation;
	while(okay<segmentation-1)//we'll keep on trying untill all points satisfy all our needs :)
		okay=0;
		for (i=0;i<nbpoints;i++)
			points[i]=rand(min,max);//we generate the points :) (their y values, their x values are 0,40,...,320
		end;
		for(i=1; i<segmentation; i++)//now we make sure the transitions are continuous :)
			currentpoint = i*(ppsegment-1)+1;//this is one point past the border between 2 segments
			points[currentpoint]=2*points[currentpoint-1]-points[currentpoint-2];//it has to be in line with the 2 previous points
			if(points[currentpoint]<max and points[currentpoint]>min)//if all corrected points still are within limits, we'll exit the while :)
				okay++;
			end;
		end;
	end;
end;
/*
method creating a landscape fragment, it does a bzier interplation from the starting point until
the stopping point, starting at firstpoint, over the next nbpoints in the given color :)
*/
function createland(nbpoints,firstpoint,start,stop,colorbacka,colorbackb,colorfronta,colorfrontb)
private
	i;
	j;
	float sum=0;//will contain the sum of all bernstein polynome values
	float pt;//float that will contain the height of the current point (so we don't get problems because it's an int)
	float prod;//yet another float to prevent problems....
	int interval;//integer that contains the width of the interval we're working over :) 
begin
	if(start > stop)//switching start and stop in case start isn't the most left x value
		i=start;
		start=stop;
		stop=i;
	end;
	interval = stop-start;
  for (i=0;i<interval;i++)//we'll have to do every x value!
  	sum=0;//setting the sum to 0 again
  	for(j=firstpoint; j<(nbpoints+firstpoint); j++)//we interpolate over all points
  		pt = points[j];//we store the current point height in a float (damn fenix!)
  		prod = bern(nbpoints-1,j-firstpoint,i,interval)*pt;//we multiply the value returned from the bernstein polynome by the height of the current point
			sum += prod/1000000;//and we add it to the sum(after deviding it by 1000.000, cause it was multiplyed by that to be able to return it as an int)
		end;
		terra[i+start]=sum;//assign the found value to the i't int in the array
		drawvline(i+start,0,terra[i+start],colorbacka,colorbackb,colorfronta,colorfrontb);//draw the land, the not land to be honest, but can be easily altered :)
	end;                                                                         
	return;
end;

/*
method drawing a vertical lign at a given x coord, with given height, and given color
the height is until where we draw, starting from the top of the screen.
*/
function drawvline(place,start,stop,colorbacka,colorbackb,colorfronta,colorfrontb)
private 
	i;
	j;
begin
	if(start > stop)//switching start and stop in case start isn't the heighest point...
		i=start;
		start=stop;
		stop=i;
	end;
	for(i =start;i<stop; i++)//iterate over all the points that have to be colored :)
		put_pixel(place,i,getcolor(i,colorbacka,colorbackb));//and color them (duhhhhhh)
	end;
	for(i=colorfrontb; i>colorfronta; i--)
		for(j=stop+5*(colorfrontb-i);j<stop+6*(colorfrontb-i+1);j++)
			 put_pixel(place,j,i);
		end;
	end;
	return;
end;
function getcolor(place,colorbacka,colorbackb)
private
	interval;
	i;
begin
	interval = 120/(colorbackb-colorbacka-1);
	if(place>119+interval/2) return colorbackb;end
	for(i=0; i<=9;i++);
		if(place>=(i-1.0/2)*interval and place <(i+1.0/2)*interval)
			if(((i-1.0/2)*interval+rand(0,interval)) >place)
				return colorbacka+i;
			else
				return colorbacka+i+1;
			end;	
		end;	
	end;
end;
//MATHEMATICAL FUNCTIONS
/*
process returning the value of the bernstein polynome
with given variables :)
*/
function bern(n,i,tme,interval)
private
	float t;
	float r;
	float tfn;
begin;
	tfn = interval-1;
	t = tme/tfn;//calculating the t for the bernstein polynome, is a value between 0 and 1, 0 when x=0, 1 when x=359 :)
	r=(binnew(n,i)*pow(1-t,n-i)*pow(t,i));//calculating the actual value
	return r*1000000;//returning 1000.000 times the found value (is between 0 and 1), because whatever we return is an int...
end;
/*
process returning binomial coefficient of n and i
*/
function binnew(n,i)
begin
	return(fac(n)/(fac(i)*fac(n-i)));// simply calculating and returning it using the formula... 
end;
/*
process returning the faculty of the given int
*/
process fac(t);
private
	r=1;
begin
	while(t>0)//as long as our number is higher than 0 (well, even 1 would be good, cause x*1 = 1 :D)
		r*=t--;//multiply the value we'll return by it, and decrease it's value
	end;
	return r;//return the found value
end;